#if !defined(AFX_ENTRYDLG_H__20000421_F5E2_D206_A027_0080AD509054__INCLUDED_)
#define AFX_ENTRYDLG_H__20000421_F5E2_D206_A027_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "FileStruct.h"
#include "MessHandler.h"

// We need a special folder dialog with
// default folder selection...
class CFolderDialogEx : public CFolderDialogImpl<CFolderDialogEx>
{
public:
   LPCTSTR m_szDefaultFolder;
   
   CFolderDialogEx(HWND hWndParent = NULL, LPCTSTR lpstrDefaultFolder = NULL, LPCTSTR lpstrTitle = NULL, UINT uFlags = BIF_RETURNONLYFSDIRS | BIF_EDITBOX)
      : CFolderDialogImpl<CFolderDialogEx>(hWndParent, lpstrTitle, uFlags)
   {
      m_szDefaultFolder = lpstrDefaultFolder;
   }
   
   void OnInitialized()
   {
      if( m_szDefaultFolder!=NULL )
         ::SendMessage(m_hWnd,BFFM_SETSELECTION,TRUE,(LPARAM)m_szDefaultFolder);
   }
};



class CEntryDlg : public CDialogImpl<CEntryDlg>
{
public:
   enum { IDD = IDD_ENTRY };

   CMessHandler *m_mess;
   tFilter *m_filter;
   tFilter m_oldfilter;
   CTabCtrl  m_ctlTab;

   CComboBox m_ctlAction;
   CEdit m_ctlTitle;
   CEdit m_ctlAuthor;
   CEdit m_ctlAlbum;
   CEdit m_ctlPattern;
   CEdit m_ctlSource;
   CEdit m_ctlTarget;
   CDateTimePickerCtrl m_ctlDate;

   BEGIN_MSG_MAP(CEntryDlg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_ID_HANDLER(IDOK, OnOk)
      COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
      COMMAND_ID_HANDLER(IDC_BROWSESOURCE, OnBrowseSource)
      COMMAND_ID_HANDLER(IDC_BROWSETARGET, OnBrowseTarget)
   END_MSG_MAP()

   CEntryDlg()
   {
      m_filter = NULL;
   };

   LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
   {
      USES_CONVERSION;
      ATLASSERT(m_filter);
      ATLASSERT(m_mess);

      // Store a copy of the original filter in case of cancel
      ::CopyMemory( &m_oldfilter, m_filter, sizeof(m_oldfilter) );

      // Add fake page to Tab control
      CString s;
      s.LoadString(IDS_TAB_ENTRY);
      m_ctlTab.Attach(GetDlgItem(IDC_TAB));
      TCITEM itm = { 0 };
      itm.mask = TCIF_TEXT;
      itm.pszText = (LPTSTR)(LPCTSTR)s;
      itm.cchTextMax = s.GetLength();
      m_ctlTab.InsertItem(0, &itm);
      // Place tab at lowest Z
      m_ctlTab.SetWindowPos(HWND_BOTTOM, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);

      m_ctlAction.Attach(GetDlgItem(IDC_ACTION));
      s.LoadString(IDS_ITEM_MOVE);
      m_ctlAction.AddString(s);
      s.LoadString(IDS_ITEM_COPY);
      m_ctlAction.AddString(s);
      s.LoadString(IDS_ITEM_DELETE);
      m_ctlAction.AddString(s);
      switch( m_filter->action ) {
      case FILEMOVE:
         m_ctlAction.SetCurSel(0);
         break;
      case FILECOPY:
         m_ctlAction.SetCurSel(1);
         break;
      case FILEDELETE:
         m_ctlAction.SetCurSel(2);
         break;
      };
      m_ctlTitle.Attach(GetDlgItem(IDC_TITLE));
      m_ctlTitle.LimitText(MAX_FILEDATA);
      m_ctlTitle.SetWindowText(W2CT(m_filter->szTitle));
      m_ctlAuthor.Attach(GetDlgItem(IDC_AUTHOR));
      m_ctlAuthor.LimitText(MAX_FILEDATA);
      m_ctlAuthor.SetWindowText(W2CT(m_filter->szAuthor));
      m_ctlAlbum.Attach(GetDlgItem(IDC_ALBUM));
      m_ctlAlbum.LimitText(MAX_FILEDATA);
      m_ctlAlbum.SetWindowText(W2CT(m_filter->szAlbum));
      m_ctlPattern.Attach(GetDlgItem(IDC_PATTERN));
      m_ctlPattern.LimitText(MAX_FILEPATTERN);
      m_ctlPattern.SetWindowText(W2CT(m_filter->szPattern));
      m_ctlSource.Attach(GetDlgItem(IDC_SOURCE));
      m_ctlSource.LimitText(MAX_PATH);
      m_ctlSource.SetWindowText(W2CT(m_filter->szSourcePath));
      m_ctlTarget.Attach(GetDlgItem(IDC_TARGET));
      m_ctlTarget.LimitText(MAX_PATH);
      m_ctlTarget.SetWindowText(W2CT(m_filter->szTargetPath));
      m_ctlDate.Attach(GetDlgItem(IDC_DATE));
      m_ctlDate.SetSystemTime(GDT_VALID, &m_filter->Date);

      CenterWindow(GetParent());
      return TRUE;
   }

   LRESULT OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      USES_CONVERSION;
      CString err;
      TCHAR szBuffer[300];

      // Grab all input

      int idx = m_ctlAction.GetCurSel();
      switch( idx ) {
      case 0:
         m_filter->action = FILEMOVE;
         break;
      case 1:
         m_filter->action = FILECOPY;
         break;
      case 2:
         m_filter->action = FILEDELETE;
         break;
      };
      m_ctlTitle.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szTitle, T2CW(szBuffer) );
      m_ctlAuthor.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szAuthor, T2CW(szBuffer) );
      m_ctlAlbum.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szAlbum, T2CW(szBuffer) );
      m_ctlPattern.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szPattern, T2CW(szBuffer) );
      m_ctlSource.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szSourcePath, T2CW(szBuffer) );
      m_ctlTarget.GetWindowText(szBuffer, 300);
      wcscpy( m_filter->szTargetPath, T2CW(szBuffer) );
      m_ctlDate.GetSystemTime(&m_filter->Date);

      // Validate all input

      if( wcslen(m_filter->szTitle)==0 ) {
         err.LoadString(IDS_ERR_INVALIDTITLE);
         MessageBox(err, NULL, MB_ICONWARNING);
         m_ctlTitle.SetFocus();
         return 0;
      };
      if( wcslen(m_filter->szPattern)==0 ) {
         err.LoadString(IDS_ERR_INVALIDPATTERN);
         MessageBox(err, NULL, MB_ICONWARNING);
         m_ctlPattern.SetFocus();
         return 0;
      };
      if( !IsValidPath(m_filter->szSourcePath) ) {
         err.LoadString(IDS_ERR_INVALIDFOLDER);
         MessageBox(err, NULL, MB_ICONWARNING);
         m_ctlSource.SetFocus();
         return 0;
      };
      if( !IsValidPath(m_filter->szTargetPath) ) {
         err.LoadString(IDS_ERR_INVALIDFOLDER);
         MessageBox(err, NULL, MB_ICONWARNING);
         m_ctlTarget.SetFocus();
         return 0;
      };
      if( wcsicmp(m_filter->szSourcePath, m_filter->szTargetPath)==0 ) {
         err.LoadString(IDS_ERR_SAMEFOLDER);
         MessageBox(err, NULL, MB_ICONWARNING);
         m_ctlTarget.SetFocus();
         return 0;
      };

      // See if any changes was made at all. In that case,
      // close the dialog with the IDCANCEL code.
      // NOTE: This is very crude match.
      if( memcmp(&m_oldfilter, m_filter, sizeof(m_oldfilter) )==0 ) {
         wID = IDCANCEL;
      };

      EndDialog(wID);
      return 0;
   }

   LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      // Copy the filter back from the original
      // (Pressing OK, with a missing entry, may have changed
      //  the filter).
      ::CopyMemory( m_filter, &m_oldfilter, sizeof(m_oldfilter) );

      EndDialog(wID);
      return 0;
   }

   LRESULT OnBrowseSource(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      USES_CONVERSION;
      static CString sLastPath;
      CString sTitle;
      sTitle.LoadString(IDS_BROWSEFOLDER);
      CString sPath( m_mess->ParseMacros(W2CT(m_filter->szSourcePath)) );
      if( sPath.IsEmpty() ) sPath = sLastPath;
      
      CFolderDialogEx dlg(m_hWnd,sPath,sTitle);
      if( dlg.DoModal()==IDOK ) {
         sLastPath = dlg.GetFolderPath();
         m_ctlSource.SetWindowText(m_mess->ScanForMacros(dlg.GetFolderPath()));
      }
      m_ctlSource.SetFocus();
      
      return 0;
   }

   LRESULT OnBrowseTarget(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      USES_CONVERSION;
      static CString sLastPath;
      CString sTitle;
      sTitle.LoadString(IDS_BROWSEFOLDER);
      CString sPath( m_mess->ParseMacros(W2CT(m_filter->szTargetPath)) );
      if( sPath.IsEmpty() ) sPath = sLastPath;
      
      CFolderDialogEx dlg(m_hWnd,sPath,sTitle);
      if( dlg.DoModal()==IDOK ) {
         sLastPath = dlg.GetFolderPath();
         m_ctlTarget.SetWindowText(m_mess->ScanForMacros(dlg.GetFolderPath()));
      }
      m_ctlTarget.SetFocus();
      
      return 0;
   }

private:
   boolean IsValidPath(LPCWSTR szFilename)
   {
      if( wcslen(szFilename)<2 ) return false;
      return true;
   };
};

#endif // !defined(AFX_ENTRYDLG_H__20000421_F5E2_D206_A027_0080AD509054__INCLUDED_)

