#if !defined(AFX_MESSHANDLER_H__20000421_20E4_9503_8B30_0080AD509054__INCLUDED_)
#define AFX_MESSHANDLER_H__20000421_20E4_9503_8B30_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileStruct.h"

//
// Written by Bjarke Viksoe (bjarke@viksoe.dk)
// Copyright (c) 2000.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. 
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability if it causes any damage to you or your
// computer whatsoever. It's free, so don't hassle me about it.
//
// Beware of bugs.
//

     
class CMessHandler
{
public:
   CMessHandler();
   ~CMessHandler();

public:
   vector<tMacro> m_Macros;
   vector<tFilter> m_Filters;
   tOptions m_options;
protected:
   CString m_strFilePath;
   CString m_strFileTitle;
   CString m_sAppPath;
   //
   bool m_bModified;
   //
   short m_nThreadCount;
   HANDLE m_hThreads[20];
   HANDLE m_hEvent;
   vector<CString> m_FolderNotified;

public:
   void Init();
   bool Open(LPCTSTR szFilename);
   bool Save(LPCTSTR szFilename);
   void Close();
   void Process(BOOL bForceRefresh=TRUE);
   tFilter GetDefaultFilter();

   boolean IsModified() const { return m_bModified; };
   void SetModified() { m_bModified = true; };
   CString FileTitle() const { return m_strFileTitle; };
   CString FileName() const { return m_strFilePath; };
   //
   CString ParseMacros(LPCTSTR szString);
   CString ScanForMacros(LPCTSTR szString);
   //
   void CreateListeners(HWND hWnd);
   void RemoveListeners();
protected:
   bool ProcessStats(tFilter &filter);
   bool ProcessEntry(tFilter &filter, BOOL *bChanged, LPCTSTR szSourcePath=NULL);
   bool CheckDiskSpace(LPCTSTR szPath);
   void LoadState();
   void SaveState();
   void CreateMonitoringThread(HWND hWnd, LPCTSTR szPath);
   CString GetFileName(LPCTSTR szFilename);
};


#endif // !defined(AFX_MESSHANDLER_H__20000421_20E4_9503_8B30_0080AD509054__INCLUDED_)

