#if !defined(AFX_OPTIONSDLG_H__20000421_435A_CC5A_F8F6_0080AD509054__INCLUDED_)
#define AFX_OPTIONSDLG_H__20000421_435A_CC5A_F8F6_0080AD509054__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileStruct.h"

class COptionsDlg : public CDialogImpl<COptionsDlg>
{
public:
   enum { IDD = IDD_OPTIONS };

   tOptions *m_options;
   CTabCtrl  m_ctlTab;
   CButton   m_ctlChangeNotify;
   CButton   m_ctlSubFolders;
   CButton   m_ctlDeleteUnmatched;
   CButton   m_ctlIgnoreDuplicates;
   CButton   m_ctlUseRecycleBin;
   CButton   m_ctlCheckDiskSpace;

   BEGIN_MSG_MAP(COptionsDlg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
   END_MSG_MAP()

   COptionsDlg()
   {
      m_options = NULL;
   };

   LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
   {
      ATLASSERT(m_options);

      // Add fake page to Tab control
      CString s;
      s.LoadString(IDS_TAB_OPTIONS);
      m_ctlTab.Attach(GetDlgItem(IDC_TAB));
      TCITEM itm = { 0 };
      itm.mask = TCIF_TEXT;
      itm.pszText = (LPTSTR)(LPCTSTR)s;
      itm.cchTextMax = s.GetLength();
      m_ctlTab.InsertItem(0, &itm);
      // Place tab at lowest Z
      m_ctlTab.SetWindowPos(HWND_BOTTOM, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE);

      m_ctlChangeNotify.Attach(GetDlgItem(IDC_AUTONOTIFY));
      m_ctlChangeNotify.SetCheck( m_options->bListenForChanges & 1 );
      m_ctlSubFolders.Attach(GetDlgItem(IDC_SUBFOLDERS));
      m_ctlSubFolders.SetCheck( m_options->bIncludeSubFolders & 1 );
      m_ctlDeleteUnmatched.Attach(GetDlgItem(IDC_AUTOREMOVE));
      m_ctlDeleteUnmatched.SetCheck( m_options->bRemoveUnmatchedFiles & 1 );
      m_ctlIgnoreDuplicates.Attach(GetDlgItem(IDC_IGNOREDUPLICATES));
      m_ctlIgnoreDuplicates.SetCheck( m_options->bIgnoreDuplicates & 1 );
      m_ctlUseRecycleBin.Attach(GetDlgItem(IDC_USERECYCLEBIN));
      m_ctlUseRecycleBin.SetCheck( m_options->bUseRecycleBin & 1 );
      m_ctlCheckDiskSpace.Attach(GetDlgItem(IDC_WATCHSPACE));
      m_ctlCheckDiskSpace.SetCheck( m_options->bCheckDiskSpace & 1 );

      CenterWindow(GetParent());
      return TRUE;
   }

   LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      m_options->bListenForChanges = m_ctlChangeNotify.GetCheck()!=0;
      m_options->bIncludeSubFolders = m_ctlSubFolders.GetCheck()!=0;
      m_options->bRemoveUnmatchedFiles = m_ctlDeleteUnmatched.GetCheck()!=0;
      m_options->bIgnoreDuplicates = m_ctlIgnoreDuplicates.GetCheck()!=0;
      m_options->bUseRecycleBin = m_ctlUseRecycleBin.GetCheck()!=0;
      m_options->bCheckDiskSpace = m_ctlCheckDiskSpace.GetCheck()!=0;

      EndDialog(wID);
      return 0;
   }
};

#endif // !defined(AFX_OPTIONSDLG_H__20000421_435A_CC5A_F8F6_0080AD509054__INCLUDED_)

